import type { PropType } from 'vue';
export type GenericObject = {
    [key: string]: any;
};
export interface OptionDescriptor {
    key: string | Symbol;
    title: string;
    subtitle?: string | null;
    searchContent?: string;
    ref?: GenericObject;
}
declare const _default: import("vue").DefineComponent<{
    modelValue: {
        type: PropType<any>;
        default: null;
    };
    loadOptions: PropType<(searchText: string | null) => Promise<GenericObject[]>>;
    options: PropType<GenericObject[]>;
    prependOptions: PropType<GenericObject[]>;
    appendOptions: PropType<GenericObject[]>;
    onCreateItem: PropType<(searchText: string) => void>;
    preload: PropType<boolean>;
    remoteSearch: PropType<boolean>;
    searchFields: PropType<string[]>;
    placeholder: PropType<string>;
    keyExtractor: PropType<(option: any) => string | symbol>;
    valueExtractor: PropType<(option: any) => any>;
    formatter: {
        type: PropType<(option: any) => string>;
        required: true;
    };
    subtitleFormatter: PropType<(option: any) => string>;
    nullTitle: PropType<string>;
    noResultsText: PropType<string>;
    disabled: PropType<boolean>;
    optionsListId: PropType<string>;
    debug: PropType<boolean>;
    required: PropType<boolean>;
}, unknown, {
    isLoading: boolean;
    isLoaded: boolean;
    loadedOptions: GenericObject[];
    isSearching: boolean;
    searchText: string;
    selectedOption: GenericObject | null;
    selectedOptionTitle: string | null;
    shouldDisplayOptions: boolean;
    highlightedOptionKey: string | Symbol | null;
    shouldShowCreateOption: boolean;
}, {
    /**
     * EFFECTIVE PROPS
     */
    effectivePrependOptions(): GenericObject[];
    effectiveAppendOptions(): GenericObject[];
    effectiveDisabled(): boolean;
    effectivePlaceholder(): string;
    effectiveNoResultsText(): string;
    effectiveKeyExtractor(): ((option: any) => any) | undefined;
    /**
     * OPTIONS GENERATION
     */
    allOptions(): GenericObject[];
    optionsDescriptors(): OptionDescriptor[];
    effectiveOptions(): OptionDescriptor[];
}, {
    loadRemoteOptions(): Promise<void>;
    reloadOptions(): Promise<void>;
    reloadOptionsIfSearching(): void;
    handleKeyDown(e: KeyboardEvent): void;
    handleInputFocused(): void;
    setHighlightedOptionKey(useFirstItemAsFallback?: boolean): void;
    getOptionKey(option: GenericObject): string | Symbol;
    getOptionDescriptor(option: GenericObject): OptionDescriptor | null;
    handleInputBlurred(): void;
    handleOptionsDisplayed(): void;
    teleportOptionsContainer(): void;
    highlightInitialOption(): void;
    handleOptionHover(option: OptionDescriptor): void;
    incrementHighlightedOption(increment: number): void;
    selectOption(option: OptionDescriptor): void;
    handleValueChanged(): void;
    addRemoteOption(option: GenericObject): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    optionsLoaded: (options: any[]) => void;
    'update:modelValue': (value: any) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    modelValue: {
        type: PropType<any>;
        default: null;
    };
    loadOptions: PropType<(searchText: string | null) => Promise<GenericObject[]>>;
    options: PropType<GenericObject[]>;
    prependOptions: PropType<GenericObject[]>;
    appendOptions: PropType<GenericObject[]>;
    onCreateItem: PropType<(searchText: string) => void>;
    preload: PropType<boolean>;
    remoteSearch: PropType<boolean>;
    searchFields: PropType<string[]>;
    placeholder: PropType<string>;
    keyExtractor: PropType<(option: any) => string | symbol>;
    valueExtractor: PropType<(option: any) => any>;
    formatter: {
        type: PropType<(option: any) => string>;
        required: true;
    };
    subtitleFormatter: PropType<(option: any) => string>;
    nullTitle: PropType<string>;
    noResultsText: PropType<string>;
    disabled: PropType<boolean>;
    optionsListId: PropType<string>;
    debug: PropType<boolean>;
    required: PropType<boolean>;
}>> & {
    "onUpdate:modelValue"?: ((value: any) => any) | undefined;
    onOptionsLoaded?: ((options: any[]) => any) | undefined;
}, {
    modelValue: any;
}, {}>;
export default _default;
