import { createWatchfulOpenapiClientGenerators } from '@signal24/openapi-client-codegen/node';
export function openapiClientGeneratorPlugin() {
    let generators = null;
    return {
        name: 'openapi-types-generator',
        apply: 'serve',
        buildStart() {
            // apply a slight delay so any output doesn't get pushed off screen
            setTimeout(() => {
                generators = createWatchfulOpenapiClientGenerators();
            }, 250);
        },
        closeBundle() {
            if (generators) {
                for (const generator of generators) {
                    generator?.close();
                }
            }
        }
    };
}
